"use strict";

exports.__esModule = true;
exports["default"] = ensureLocationMiddleware;

var _ActionTypes = _interopRequireDefault(require("./ActionTypes"));

var _ensureLocation = _interopRequireDefault(require("./ensureLocation"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ensureLocationMiddleware() {
  return function (next) {
    return function (action) {
      var type = action.type,
          payload = action.payload;

      switch (type) {
        case _ActionTypes["default"].PUSH:
          return next({
            type: _ActionTypes["default"].NAVIGATE,
            payload: _extends({}, (0, _ensureLocation["default"])(payload), {
              action: 'PUSH'
            })
          });

        case _ActionTypes["default"].REPLACE:
          return next({
            type: _ActionTypes["default"].NAVIGATE,
            payload: _extends({}, (0, _ensureLocation["default"])(payload), {
              action: 'REPLACE'
            })
          });

        case _ActionTypes["default"].CREATE_HREF:
        case _ActionTypes["default"].CREATE_LOCATION:
          return next({
            type: type,
            payload: (0, _ensureLocation["default"])(payload)
          });

        default:
          return next(action);
      }
    };
  };
}

module.exports = exports.default;